//-----------------------------------------------------------------------------------------------------
//fPPZ_levels.mqh  2012/05/07
//     PPZ  
//   : Dserg (http://www.mql4.com/ru/users/Dserg)
//-----------------------------------------------------------------------------------------------------
#property copyright "midorum, 2012"
#property link      "midorum@gmail.com"
//-----------------------------------------------------------------------------------------------------
//    :
//-----------------------------------------------------------------------------------------------------
//    int GetPPZLevels(int timeframe, double& levels[], double& disp[], int num_levels=10, int common_fractals=100, int num_fractals=4, int space=5, int start=0)
//
//      ppz-       levels[],       disp[]
//:
// int timeframe - ,     ,           MQL4 (PERIOD_M1-PERIOD_MN1)
// double& levels[] -     ,      ,    GetPPZLevels
// double& disp[] -      ,      ,    GetPPZLevels
// int num_levels=10 -  ,   
// int common_fractals=100 -   ,     
// int num_fractals=4 -      
// int space=5 -    ,   
// int start=0 -  ,       
// :
//     
//       :
//  -1 - memory allocation error/     
//-----------------------------------------------------------------------------------------------------
//    int ShowPPZLevels(int timeframe, double& levels[], double& disp[], int founded, color clr, int width, int style, string info="")
//
//      ppz-,      levels  disp.        GetPPZLevels.
//:
// int timeframe - ,       GetPPZLevels,           MQL4 (PERIOD_M1-PERIOD_MN1)
// double& levels[] -   ,      
// double& disp[] -    ,      
// int founded -  ,   GetPPZLevels
// color clr -      Web-
// int width -   
// int style -   ,           MQL4 (STYLE_SOLID-STYLE_DASHDOTDOT)
// string info="" -  ,      
// :
//   0   
//       
//-----------------------------------------------------------------------------------------------------
//    int DeletePPZLevels()
//
//          ShowPPZLevels ppz-.
//:          "_ppz_"    .       ,       .
//:
// 
// :
//   0   
//       
//-----------------------------------------------------------------------------------------------------
int GetPPZLevels(int timeframe, double& levels[], double& disp[], int num_levels=10, int common_fractals=100, int num_fractals=4, int space=5, int start=0)
{
   double fr[], average, cur_disp;
   int fr_bar[], sel_bar[], sel_fr[], cur_fr[], found, i, j, k, l, m;
   bool flag=false;
   if(ArrayResize(fr,common_fractals)==-1) flag=true;
   if(ArrayResize(fr_bar,common_fractals)==-1) flag=true;
   if(ArrayResize(levels,num_levels)==-1) flag=true;
   if(ArrayResize(disp,num_levels)==-1) flag=true;
   if(ArrayResize(sel_bar,num_fractals)==-1) flag=true;
   if(ArrayResize(sel_fr,num_fractals)==-1) flag=true;
   if(ArrayResize(cur_fr,num_fractals)==-1) flag=true;
   if(flag) return(-1);
   ArrayInitialize(disp,999999999);
   j=iBars(NULL,timeframe)-1;
   for(i=start,found=0; i<j && found<common_fractals; i++)
   {
      fr[found]=iFractals(NULL,timeframe,MODE_UPPER,i);
      if (fr[found]!=0)
      {
         fr_bar[found]=i;
         found++;
      }
      fr[found]=iFractals(NULL,timeframe,MODE_LOWER,i);
      if (fr[found]!=0)
      {
         fr_bar[found]=i;
         found++;
      }
   }
   j=found;
   flag=true;
   while (j>1 || flag)
   {
      if (j>1) j=j/1.25;
      flag=false;
      for(i=0; (i+j)<found; i++)
      if(fr[i]>fr[i+j])
      {
         average=fr[i]; fr[i]=fr[i+j]; fr[i+j]=average;
         average=fr_bar[i]; fr_bar[i]=fr_bar[i+j]; fr_bar[i+j]=average;
         flag = true;
      }
   }
   for(l=0; l<num_levels; l++)
   {
      if(l>0)
         for(i=found-1; i>=0; i--)
         {
            if(fr[i]==0)
            {
               found--;
               for(j=i; j<found; j++)
               {
                  fr[j]=fr[j+1];
                  fr_bar[j]=fr_bar[j+1];
               }
            }
         }   
      for(i=0; i<=found-num_fractals; i++)
      {
         average=0; cur_disp=0; ArrayInitialize(sel_bar,-1);
         for(j=i,k=0; j<found && k<num_fractals; j++)
         {
            for(m=0; m<num_fractals; m++)
            {
               if(sel_bar[m]!=-1)
               {
                  if(MathAbs(sel_bar[m]-fr_bar[j])<space)
                  {
                     flag=false;
                     break;
                  }
               }
               else
               {
                  sel_bar[m]=fr_bar[j];
                  flag=true;
                  break;
               }
            }
            if(flag)
            {
               cur_fr[k]=j;
               k++;
            }
         }
         if(j==found && k<num_fractals) continue;
         for(j=0;j<num_fractals;j++) average+=fr[cur_fr[j]];
         average/=num_fractals;
         for(j=0;j<num_fractals;j++) cur_disp+=MathPow(fr[cur_fr[j]]-average,2);
         if(cur_disp<disp[l])
         {
            disp[l]=cur_disp;
            levels[l]=average;
            for(j=0;j<num_fractals;j++) sel_fr[j]=cur_fr[j];
         }
      }
      if(disp[l]==999999999) break;
      for(i=0;i<num_fractals;i++) fr[sel_fr[i]]=0;
   }
   return(l);
}
//-----------------------------------------------------------------------------------------------------
int ShowPPZLevels(int timeframe, double& levels[], double& disp[], int founded, color clr, int width, int style, string info="")
{
   int i,visibility;
   string name, period;
   switch (timeframe)
   {
   case PERIOD_M1:
      period="min";
      visibility=0x0001;
      break;
   case PERIOD_M5:
      period="5min";
      visibility=0x0003;
      break;
   case PERIOD_M15:
      period="15min";
      visibility=0x0007;
      break;
   case PERIOD_M30:
      period="30min";
      visibility=0x000f;
      break;
   case PERIOD_H1:
      period="hour";
      visibility=0x001f;
      break;
   case PERIOD_H4:
      period="4hour";
      visibility=0x003f;
      break;
   case PERIOD_D1:
      period="day";
      visibility=0x007f;
      break;
   case PERIOD_W1:
      period="week";
      visibility=0x00ff;
      break;
   case PERIOD_MN1:
      period="month";
      visibility=0x01ff;
      break;
   }
   for(i=0; i<founded; i++)
   {
      name=StringConcatenate(period,"_ppz_",i,"_",info);
      ObjectCreate(name,OBJ_HLINE,0,0,NormalizeDouble(levels[i],Digits));
      ObjectSet(name,OBJPROP_COLOR,clr);
      ObjectSet(name,OBJPROP_WIDTH,width);
      ObjectSet(name,OBJPROP_STYLE,style);
      ObjectSet(name,OBJPROP_TIMEFRAMES,visibility);
      ObjectSetText(name,"disp:"+DoubleToStr(disp[i],8));
   }
   return(0);
}
//-----------------------------------------------------------------------------------------------------
int DeletePPZLevels()
{
   int i;
   string name;
   for(i=ObjectsTotal()-1;i>=0;i--)
   {
      name="_ppz_";
      if(StringFind(ObjectName(i),name)!=-1) ObjectDelete(ObjectName(i));
   }
   return(0);
}
//-----------------------------------------------------------------------------------------------------

