//-----------------------------------------------------------------------------------------------------
//sPPZ_sample2.mq4
//-----------------------------------------------------------------------------------------------------
//   ppz-        fPPZ_levels.mqh
//      fPPZ_levels.mqh   ...\MetaTrader 4\experts\include
//       ...\MetaTrader 4\experts\scripts
//-----------------------------------------------------------------------------------------------------
#property copyright "midorum, 2012"
#property link      "midorum@gmail.com"
#property show_inputs

#include <fPPZ_levels.mqh>

//  -       ,      
//  ,     "",  ,      
//       ""  (,     )
extern string a0="  ";
extern int number_of_levels=10;
//  -        , ..  
//       "" ,   ,   
// ,    "" ,     
extern string a1="   ";
extern int common_fractals=100;
//     
//,       ,   ,      
//      "" , ..     
extern string a2="    ";
extern int fractals_per_level=4;
//      "" , ..     
extern string a3="     ";
extern int fractals_space=5;
//
extern string a4="  () ";
extern int start_bar=0;
//
extern string a5=" : 0()-4()";
extern int start_period=2;
//
extern string a6="     ";
extern bool DeleteAll=false;

//       ,  
double PPZ_levels[];//  ppz-
double dispersions[];//  ppz- (    )

//   
int period[5]={PERIOD_H1,PERIOD_H4,PERIOD_D1,PERIOD_W1,PERIOD_MN1};
color period_color[5]={PaleGreen,PaleGreen,Coral,CornflowerBlue,DarkSlateBlue};
int period_width[5]={1,1,1,2,3};
int period_style[5]={1,1,0,0,0};
//-----------------------------------------------------------------------------------------------------
int start()
{
   int i;//index
   int founded;//  
   string report;//  

   if(DeleteAll)//   
   {
      DeletePPZLevels();
      Comment("");
      return(0);
   }
   //      
   if(MessageBox("Delete old ppz-levels?\n  ppz-?",NULL,0x00000024)==6) DeletePPZLevels();

   for(i=start_period; i<5; i++)// 
   {
      // ppz-   
      founded=GetPPZLevels(period[i], PPZ_levels, dispersions, number_of_levels, common_fractals, fractals_per_level, fractals_space, start_bar);
      //   :
      // PPZ_levels -   ,     ,       ShowPPZLevels
      // dispersions -   ,     ,       ShowPPZLevels
      // founded -      ,        ShowPPZLevels

      if(founded==-1)//  
      {
         MessageBox("Memory allocation error\n   ",NULL,0x00000030);
         return(-1);
      }

      switch (period[i])
      {
      case PERIOD_H1:
         report=StringConcatenate(report,"hour: found ");
         break;
      case PERIOD_H4:
         report=StringConcatenate(report,"4hour: found ");
         break;
      case PERIOD_D1:
         report=StringConcatenate(report,"day: found ");
         break;
      case PERIOD_W1:
         report=StringConcatenate(report,"week: found ");
         break;
      case PERIOD_MN1:
         report=StringConcatenate(report,"month: found ");
         break;
      }
      report=StringConcatenate(report,founded," ppz-levels\n");

      //    (      ,     )
      ShowPPZLevels(period[i], PPZ_levels, dispersions, founded, period_color[i], period_width[i], period_style[i], "("+DoubleToStr(fractals_per_level,0)+")");
      
   }

   Comment(report);//    

   return(0);
}
//-----------------------------------------------------------------------------------------------------

